cdac.medinfo.sdk.hl7282.baselibs.segments

## Class BPX

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.BPX

- All Implemented Interfaces:
    ISegment

      public class BPX
      extends Segment

  BPX - Blood Product Dispense Status Segment.

  In the processing of blood products, it is necessary for the transfusion service and the placer system to communicate information.The status messages need to contain additional information regarding the blood products requested, such as the unique donation ID, product code, blood type, expiration date/time of the blood product, and current status of the product. BPX segment is contains additional attributes that helps in above requirements.

  Represents an HL7 BPX message segment. This segment has the following fields:

  BPX-1: Set ID _ BPX (SI)Required
  BPX-2: BP Dispense Status (CWE)Required
  BPX-3: BP Status (ID)Required
  BPX-4: BP Date/Time of Status (DTM)Required
  BPX-5: BC Donation ID (EI)Conditional
  BPX-6: BC Component (CNE)Conditional
  BPX-7: BC Donation Type / Intended Use (CNE)Optional
  BPX-8: CP Commercial Product (CWE)Conditional
  BPX-9: CP Manufacturer (XON)Conditional
  BPX-10: CP Lot Number (EI)Conditional
  BPX-11: BP Blood Group (CNE)Optional
  BPX-12: BC Special Testing (CNE)Optional
  BPX-13: BP Expiration Date/Time (DTM)Optional
  BPX-14: BP Quantity (NM)Required
  BPX-15: BP Amount (NM)Optional
  BPX-16: BP Units (CWE)Optional
  BPX-17: BP Unique ID (EI)Optional
  BPX-18: BP Actual Dispensed To Location (PL)Optional
  BPX-19: BP Actual Dispensed To Address (XAD)Optional
  BPX-20: BP Dispensed to Receiver (XCN)Optional
  BPX-21: BP Dispensing Individual (XCN)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BPX()` Constructs the BPX segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addBCSpecialTesting(CNE objbCSpecialTesting)` Add the BC Special Testing.
    `void` | `addBCSpecialTesting(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the BC Special Testing This field specify the field Which allow multiple entries for special testing that is performed on the blood component.
    `CNE` | `getBCComponent()` Retrieves the BC Component.
    `EI` | `getBCDonationID()` Retrieves the BC Donation ID.
    `CNE` | `getBCDonationTypeIntendedUse()` Retrieves the BC Donation Type Intended Use.
    `ISingleCollection<CNE>` | `getBCSpecialTesting()` Retrieves the BC Special Testing This field specify the field Which allow multiple entries for special testing that is performed on the blood component.
    `XAD` | `getBPActualDispensedToAddress()` Retrieves the BP Actual Dispensed To Address.
    `PL` | `getBPActualDispensedToLocation()` Retrieves the BP Actual Dispensed To Location.
    `NM` | `getBPAmount()` Retrieves the BP Amount.
    `CNE` | `getBPBloodGroup()` Retrieves the BP Blood Group.
    `DTM` | `getBPDateTimeofStatus()` Retrieves the BP Date Time of Status.
    `XCN` | `getBPDispensedtoReceiver()` Retrieves the BP Dispensed to Receiver.
    `CWE` | `getBPDispenseStatus()` Retrieves the BP Dispense Status.
    `XCN` | `getBPDispensingIndividual()` Retrieves the BP Dispensing Individual.
    `DTM` | `getBPExpirationDateTime()` Retrieves the BP Expiration Date Time.
    `NM` | `getBPQuantity()` Retrieves the BP Quantity.
    `ID` | `getBPStatus()` Retrieves the BP Status.
    `EI` | `getBPUniqueID()` Retrieves the BP Unique ID.
    `CWE` | `getBPUnits()` Retrieves the BP Units.
    `CWE` | `getCPCommercialProduct()` Retrieves the CP Commercial Product.
    `EI` | `getCPLotNumber()` Retrieves the CP Lot Number.
    `XON` | `getCPManufacturer()` Retrieves the CP Manufacturer.
    `SI` | `getSetID_BPX()` Retrieves the Set ID BPX.
    `void` | `setBCComponent(CNE objbCComponent)` Set the BC Component.
    `void` | `setBCComponent(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the BC Component.
    `void` | `setBCDonationID(EI objbCDonationID)` Set the BC Donation ID.
    `void` | `setBCDonationID(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the BC Donation ID.
    `void` | `setBCDonationTypeIntendedUse(CNE objbCDonationTypeIntendedUse)` Set the BC Donation Type Intended Use.
    `void` | `setBCDonationTypeIntendedUse(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the BC Donation Type Intended Use.
    `void` | `setBCSpecialTesting(ISingleCollection<CNE> objbCSpecialTestingList)` Set the BC Special Testing.
    `void` | `setBPActualDispensedToAddress(SAD objStreetAddress, java.lang.String strOtherDesignation, java.lang.String strCity, java.lang.String strStateOrProvince, java.lang.String strZipOrPostalCode, java.lang.String strCountry, java.lang.String strAddressType, java.lang.String strOtherGeographicDesignation, CWE objCountyParishCode, CWE objCensusTract, java.lang.String strAddressRepresentationCode, DTM objEffectiveDate, DTM objExpirationDate, CWE objEXpirationReason, java.lang.String strTemporaryIndicator, java.lang.String strBadAddressIndicator, java.lang.String strAddressUsage, java.lang.String strAddressee, java.lang.String strComment, java.lang.String strPreferenceOrder, CWE objProtectionCode, EI objAddressIdentifier)` Set the BP Actual Dispensed To Address.
    `void` | `setBPActualDispensedToAddress(XAD objbPActualDispensedToAddress)` Set the BP Actual Dispensed To Address.
    `void` | `setBPActualDispensedToLocation(HD objPointOfCare, HD objRoom, HD objBed, HD objFacility, java.lang.String strLocationStatus, java.lang.String strPersonLocationType, java.lang.String strBuilding, java.lang.String strFloor, java.lang.String strLocationDescription, EI objComprehensiveLocationIdentifier, HD objAssigningAuthorityForLocation)` Set the BP Actual Dispensed To Location.
    `void` | `setBPActualDispensedToLocation(PL objbPActualDispensedToLocation)` Set the BP Actual Dispensed To Location.
    `void` | `setBPAmount(NM objbPAmount)` Set the BP Amount.
    `void` | `setBPAmount(java.lang.String strBPAmount)` Set the BP Amount.
    `void` | `setBPBloodGroup(CNE objbPBloodGroup)` Set the BP Blood Group.
    `void` | `setBPBloodGroup(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionID, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameOfSecondAltenateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the BP Blood Group.
    `void` | `setBPDateTimeofStatus(DTM objbPDateTimeofStatus)` Set the BP Date Time of Status.
    `void` | `setBPDateTimeofStatus(java.lang.String strTime)` Set the BP Date Time of Status.
    `void` | `setBPDispensedtoReceiver(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Set the BP Dispensed to Receiver.
    `void` | `setBPDispensedtoReceiver(XCN objbPDispensedtoReceiver)` Set the BP Dispensed to Receiver.
    `void` | `setBPDispenseStatus(CWE objbPDispenseStatus)` Set the BP Dispense Status.
    `void` | `setBPDispenseStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the BP Dispense Status.
    `void` | `setBPDispensingIndividual(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Set the BP Dispensing Individual.
    `void` | `setBPDispensingIndividual(XCN objbPDispensingIndividual)` Set the BP Dispensing Individual.
    `void` | `setBPExpirationDateTime(DTM objbPExpirationDateTime)` Set the BP Expiration Date Time.
    `void` | `setBPExpirationDateTime(java.lang.String strTime)` Set the BP Expiration Date Time.
    `void` | `setBPQuantity(NM objbPQuantity)` Set the BP Quantity.
    `void` | `setBPQuantity(java.lang.String strBPquantity)` Set the BP Quantity.
    `void` | `setBPStatus(ID objbPStatus)` Set the BP Status.
    `void` | `setBPStatus(java.lang.String strBPstatus)` Set the BP Status.
    `void` | `setBPUniqueID(EI objbPUniqueID)` Set the BP Unique ID.
    `void` | `setBPUniqueID(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the BP Unique ID.
    `void` | `setBPUnits(CWE objbPUnits)` Set the BP Units.
    `void` | `setBPUnits(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the BP Units.
    `void` | `setCPCommercialProduct(CWE objcPCommercialProduct)` Set the CP Commercial Product.
    `void` | `setCPCommercialProduct(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the CP Commercial Product.
    `void` | `setCPLotNumber(EI objcPLotNumber)` Set the CP Lot Number.
    `void` | `setCPLotNumber(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the CP Lot Number.
    `void` | `setCPManufacturer(java.lang.String strOrganizationName, CWE objOrganizationNameTypeCode, HD objAssigningAuthority, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, java.lang.String strOrganizationIdentifier)` Set the CP Manufacturer.
    `void` | `setCPManufacturer(XON objcPManufacturer)` Set the CP Manufacturer.
    `void` | `setSetID_BPX(SI objsetID_BPX)` Set the Set ID BPX.
    `void` | `setSetID_BPX(java.lang.String strSetID_BPX)` Set the Set ID BPX.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BPX

          public BPX()

      Constructs the BPX segment.

  - ### Method Detail

    - #### getBCComponent

          public CNE getBCComponent()

      Retrieves the BC Component. This field specify the identifier and description of the specific blood component.
      Returns:
        CNE - bCComponent

    - #### getBCDonationID

          public EI getBCDonationID()

      Retrieves the BC Donation ID. This field specify the unique identification number assigned to a blood donation.
      Returns:
        EI - bCDonationID

    - #### getBCDonationTypeIntendedUse

          public CNE getBCDonationTypeIntendedUse()

      Retrieves the BC Donation Type Intended Use.
      Returns:
        CNE - bCDonationTypeIntendedUse

    - #### getBCSpecialTesting

          public ISingleCollection<CNE> getBCSpecialTesting()

      Retrieves the BC Special Testing This field specify the field Which allow multiple entries for special testing that is performed on the blood component.
      Returns:
        ISingleCollection - bCSpecialTesting

    - #### getBPActualDispensedToAddress

          public XAD getBPActualDispensedToAddress()

      Retrieves the BP Actual Dispensed To Address. This field specify the actual address of the location to which the blood product is actually dispense.
      Returns:
        XAD - bPActualDispensedToAddress

    - #### getBPActualDispensedToLocation

          public PL getBPActualDispensedToLocation()

      Retrieves the BP Actual Dispensed To Location. This field specify the inpatient or outpatient location to which the blood product is actually dispense.
      Returns:
        PL - bPActualDispensedToLocation

    - #### getBPAmount

          public NM getBPAmount()

      Retrieves the BP Amount. This field specify the order amount(volume) associated with each quantity of a blood component or commercial product to which this message refers.
      Returns:
        NM - bPAmount

    - #### getBPBloodGroup

          public CNE getBPBloodGroup()

      Retrieves the BP Blood Group. This field specify the ABO/Rh blood group of the blood component.
      Returns:
        CNE - bPBloodGroup

    - #### getBPDateTimeofStatus

          public DTM getBPDateTimeofStatus()

      Retrieves the BP Date Time of Status. This field specify the date and time that the status of the blood component is change.
      Returns:
        DTM - bPDateTimeofStatus

    - #### getBPDispensedtoReceiver

          public XCN getBPDispensedtoReceiver()

      Retrieves the BP Dispensed to Receiver.
      Returns:
        XCN - bPDispensedtoReceiver

    - #### getBPDispenseStatus

          public CWE getBPDispenseStatus()

      Retrieves the BP Dispense Status. This field specify the current status of the specified blood product as indicated by the filler or placer.
      Returns:
        CWE - bPDispenseStatus

    - #### getBPDispensingIndividual

          public XCN getBPDispensingIndividual()

      Retrieves the BP Dispensing Individual. This field specify the identify the individual who is dispensing the blood component or commercial product.
      Returns:
        XCN - bPDispensingIndividual

    - #### getBPExpirationDateTime

          public DTM getBPExpirationDateTime()

      Retrieves the BP Expiration Date Time. This field specify the date and time that the blood product expires.
      Returns:
        DTM - bPExpirationDateTime

    - #### getBPQuantity

          public NM getBPQuantity()

      Retrieves the BP Quantity. This field specify the number of blood components or commercial products to which this message refers.
      Returns:
        NM - bPQuantity

    - #### getBPStatus

          public ID getBPStatus()

      Retrieves the BP Status.
      Returns:
        ID - bPStatus

    - #### getBPUniqueID

          public EI getBPUniqueID()

      Retrieves the BP Unique ID. This field specify the unique system-generated number assigned to the blood product to which the message is referring.
      Returns:
        EI - bPUniqueID

    - #### getBPUnits

          public CWE getBPUnits()

      Retrieves the BP Units. This field specify the units of measure for the blood product amount.
      Returns:
        CWE - bPUnits

    - #### getCPCommercialProduct

          public CWE getCPCommercialProduct()

      Retrieves the CP Commercial Product. This field specify the code and/or text to identify a commercial product.
      Returns:
        CWE - cPCommercialProduct

    - #### getCPLotNumber

          public EI getCPLotNumber()

      Retrieves the CP Lot Number. This field specify the lot number for blood derivatives or commercially supplied items used as accessories to transfusion.
      Returns:
        EI - cPLotNumber

    - #### getCPManufacturer

          public XON getCPManufacturer()

      Retrieves the CP Manufacturer. This field specify the manufacturer of the commercial product.
      Returns:
        XON - cPManufacturer

    - #### getSetID_BPX

          public SI getSetID_BPX()

      Retrieves the Set ID BPX. This field specify the sequence number for the BPX segment under the related BPO segment.
      Returns:
        SI - setID_BPX

    - #### setBCComponent

          public void setBCComponent(java.lang.String strIdentifier,
                            java.lang.String strText,
                            java.lang.String strNameOfCodingSystem,
                            java.lang.String strAlternateIdentifier,
                            java.lang.String strAlternateText,
                            java.lang.String strNameOfAlternateCodingSystem,
                            java.lang.String strCodingSystemVersionID,
                            java.lang.String strAlternateCodingSystemVersionID,
                            java.lang.String strOriginalText,
                            java.lang.String strSecondAlternateIdentifier,
                            java.lang.String strSecondAlternateText,
                            java.lang.String strNameOfSecondAltenateCodingSystem,
                            java.lang.String strSecondAlternateCodingSystemVersionID,
                            java.lang.String strCodingSystemOID,
                            java.lang.String strValueSetOID,
                            java.lang.String strValueSetVersionID,
                            java.lang.String strAlternateCodingSystemOID,
                            java.lang.String strAlternateValueSetOID,
                            java.lang.String strAlternateValueSetVersionID,
                            java.lang.String strSecondAlternateCodingSystemOID,
                            java.lang.String strSecondAlternateValueSetOID,
                            java.lang.String strSecondAlternateValueSetVersionID)

      Set the BC Component. This field specify the identifier and description of the specific blood component.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setBCComponent

          public void setBCComponent(CNE objbCComponent)

      Set the BC Component. This field specify the identifier and description of the specific blood component.
      Parameters:
        `objbCComponent` - Object of BC Component.

    - #### setBCDonationID

          public void setBCDonationID(java.lang.String strEntityIdentifier,
                             java.lang.String strNamespaceId,
                             java.lang.String strUniversalId,
                             java.lang.String strUniversalIdType)

      Set the BC Donation ID. This field specify the unique identification number assigned to a blood donation.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setBCDonationID

          public void setBCDonationID(EI objbCDonationID)

      Set the BC Donation ID. This field specify the unique identification number assigned to a blood donation.
      Parameters:
        `objbCDonationID` - Object of BC Donation ID.

    - #### setBCDonationTypeIntendedUse

          public void setBCDonationTypeIntendedUse(java.lang.String strIdentifier,
                                          java.lang.String strText,
                                          java.lang.String strNameOfCodingSystem,
                                          java.lang.String strAlternateIdentifier,
                                          java.lang.String strAlternateText,
                                          java.lang.String strNameOfAlternateCodingSystem,
                                          java.lang.String strCodingSystemVersionID,
                                          java.lang.String strAlternateCodingSystemVersionID,
                                          java.lang.String strOriginalText,
                                          java.lang.String strSecondAlternateIdentifier,
                                          java.lang.String strSecondAlternateText,
                                          java.lang.String strNameOfSecondAltenateCodingSystem,
                                          java.lang.String strSecondAlternateCodingSystemVersionID,
                                          java.lang.String strCodingSystemOID,
                                          java.lang.String strValueSetOID,
                                          java.lang.String strValueSetVersionID,
                                          java.lang.String strAlternateCodingSystemOID,
                                          java.lang.String strAlternateValueSetOID,
                                          java.lang.String strAlternateValueSetVersionID,
                                          java.lang.String strSecondAlternateCodingSystemOID,
                                          java.lang.String strSecondAlternateValueSetOID,
                                          java.lang.String strSecondAlternateValueSetVersionID)

      Set the BC Donation Type Intended Use.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setBCDonationTypeIntendedUse

          public void setBCDonationTypeIntendedUse(CNE objbCDonationTypeIntendedUse)

      Set the BC Donation Type Intended Use.
      Parameters:
        `objbCDonationTypeIntendedUse` - object of BC Donation Type Intended Use.

    - #### addBCSpecialTesting

          public void addBCSpecialTesting(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionID,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameOfSecondAltenateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Add the BC Special Testing This field specify the field Which allow multiple entries for special testing that is performed on the blood component.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### addBCSpecialTesting

          public void addBCSpecialTesting(CNE objbCSpecialTesting)

      Add the BC Special Testing. This field specify the field Which allow multiple entries for special testing that is performed on the blood component.
      Parameters:
        `objbCSpecialTesting` - Object of BC Special Testing.

    - #### setBCSpecialTesting

          public void setBCSpecialTesting(ISingleCollection<CNE> objbCSpecialTestingList)

      Set the BC Special Testing. This field specify the field Which allow multiple entries for special testing that is performed on the blood component.
      Parameters:
        `objbCSpecialTestingList` - List of BC Special Testing.

    - #### setBPActualDispensedToAddress

          public void setBPActualDispensedToAddress(SAD objStreetAddress,
                                           java.lang.String strOtherDesignation,
                                           java.lang.String strCity,
                                           java.lang.String strStateOrProvince,
                                           java.lang.String strZipOrPostalCode,
                                           java.lang.String strCountry,
                                           java.lang.String strAddressType,
                                           java.lang.String strOtherGeographicDesignation,
                                           CWE objCountyParishCode,
                                           CWE objCensusTract,
                                           java.lang.String strAddressRepresentationCode,
                                           DTM objEffectiveDate,
                                           DTM objExpirationDate,
                                           CWE objEXpirationReason,
                                           java.lang.String strTemporaryIndicator,
                                           java.lang.String strBadAddressIndicator,
                                           java.lang.String strAddressUsage,
                                           java.lang.String strAddressee,
                                           java.lang.String strComment,
                                           java.lang.String strPreferenceOrder,
                                           CWE objProtectionCode,
                                           EI objAddressIdentifier)

      Set the BP Actual Dispensed To Address. This field specify the actual address of the location to which the blood product is actually dispense.
      Parameters:
        `objStreetAddress` - Specifies the street address.
        `strOtherDesignation` - Specifies the Second line of address.
        `strCity` - The city, or district or place where the addressee is located.
        `strStateOrProvince` - Specifies the state or province where the addressee is located.
        `strZipOrPostalCode` - Specifies the zip or postal code where the addressee is located.
        `strCountry` - Specifies the country where the addressee is located.
        `strAddressType` - Specifies the kind or type of address.
        `strOtherGeographicDesignation` - Specifies any other geographic designation.
        `objCountyParishCode` - Specifies a code that represents the county in which the specified address resides.
        `objCensusTract` - Specifies a code that represents the census tract in which the specified address resides.
        `strAddressRepresentationCode` - Specifies representations of the same name/address Suggested values are I,A,P [Refer table 0465]
        `objEffectiveDate` - It is The first date, if known, on which the address is valid and active.
        `objExpirationDate` - It is The last date, if known, on which the address is valid and active.
        `objExpirationReason` - indicates why this address was marked as ended.
        `strTemporaryIndicator` - indicates whether address is considered temporary .
        `strBadAddressIndicator` - indicates whether it is possible to contact the owning entity.
        `strAddressUsage` - indicates how the address is intended to be used.
        `strAddressee` - indicates the name of the person whose address is intended to be used.
        `strComment` - indicated descriptive information
        `strPreferenceOrder` - preference order
        `objProtectionCode` - indicates that an address need to be protected
        `objAdressIdentifier` - indicates a unique identifier for address

    - #### setBPActualDispensedToAddress

          public void setBPActualDispensedToAddress(XAD objbPActualDispensedToAddress)

      Set the BP Actual Dispensed To Address. This field specify the actual address of the location to which the blood product is actually dispense.
      Parameters:
        `objbPActualDispensedToAddress` - Object of BP Actual Dispensed To Address.

    - #### setBPActualDispensedToLocation

          public void setBPActualDispensedToLocation(HD objPointOfCare,
                                            HD objRoom,
                                            HD objBed,
                                            HD objFacility,
                                            java.lang.String strLocationStatus,
                                            java.lang.String strPersonLocationType,
                                            java.lang.String strBuilding,
                                            java.lang.String strFloor,
                                            java.lang.String strLocationDescription,
                                            EI objComprehensiveLocationIdentifier,
                                            HD objAssigningAuthorityForLocation)

      Set the BP Actual Dispensed To Location. This field specify the inpatient or outpatient location to which the blood product is actually dispense.
      Parameters:
        `strPointOfCare` - Specifies the code for the point where patient care is administered.
        `strRoom` - Specifies the code for the patient's room.
        `strBed` - Specifies the code for the patient's bed.
        `objFacility` - Specifies to site interpretation but generally describes the highest level physical designation of an institution, medical center or enterprise.
        `strLocationStatus` - Specifies the code for the status or availability of the location.
        `strPersonLocationType` - Specifies the categorization of the person's location defined by facility, building, floor, point of care, room or bed.
        `strBuilding` - Specifies code for the building where the person is located.
        `strFloor` - Specifies the code for the floor where the person is located.
        `strLocationDescription` - Specifies describes the location in free text.
        `objComprehensiveLocationIdentifier` - Specifies represents the physical location as a whole without regard for the individual components.
        `objAssigningAuthorityForLocation` - Specifies the entity that creates the data for the individual physical location components.

    - #### setBPActualDispensedToLocation

          public void setBPActualDispensedToLocation(PL objbPActualDispensedToLocation)

      Set the BP Actual Dispensed To Location. This field specify the inpatient or outpatient location to which the blood product is actually dispense.
      Parameters:
        `objbPActualDispensedToLocation` - Object of BP Actual Dispensed To Location.

    - #### setBPAmount

          public void setBPAmount(java.lang.String strBPAmount)

      Set the BP Amount. This field specify the order amount(volume) associated with each quantity of a blood component or commercial product to which this message refers.
      Parameters:
        `strBPAmount` - This field contains the String Value of Amount.

    - #### setBPAmount

          public void setBPAmount(NM objbPAmount)

      Set the BP Amount. This field specify the order amount(volume) associated with each quantity of a blood component or commercial product to which this message refers.
      Parameters:
        `objbPAmount` - Object of BP Amount.

    - #### setBPBloodGroup

          public void setBPBloodGroup(java.lang.String strIdentifier,
                             java.lang.String strText,
                             java.lang.String strNameOfCodingSystem,
                             java.lang.String strAlternateIdentifier,
                             java.lang.String strAlternateText,
                             java.lang.String strNameOfAlternateCodingSystem,
                             java.lang.String strCodingSystemVersionID,
                             java.lang.String strAlternateCodingSystemVersionID,
                             java.lang.String strOriginalText,
                             java.lang.String strSecondAlternateIdentifier,
                             java.lang.String strSecondAlternateText,
                             java.lang.String strNameOfSecondAltenateCodingSystem,
                             java.lang.String strSecondAlternateCodingSystemVersionID,
                             java.lang.String strCodingSystemOID,
                             java.lang.String strValueSetOID,
                             java.lang.String strValueSetVersionID,
                             java.lang.String strAlternateCodingSystemOID,
                             java.lang.String strAlternateValueSetOID,
                             java.lang.String strAlternateValueSetVersionID,
                             java.lang.String strSecondAlternateCodingSystemOID,
                             java.lang.String strSecondAlternateValueSetOID,
                             java.lang.String strSecondAlternateValueSetVersionID)

      Set the BP Blood Group. This field specify the ABO/Rh blood group of the blood component.
      Parameters:
        `strIdentifier` - Specifies sequence of characters (the code) that uniquely identifies the item being referenced by the CNE.
        `strText` - Specifies descriptive or textual name of the identifier, e.g., myocardial infarction
        `strNameOfCodingSystem` - Specifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies the local or user seen code as described.
        `strAlternateText` - Specifies descriptive or textual name of the alternate identifier.
        `strNameOfAlternateCodingSystem` - Specifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - Specifies the version ID for the coding system.
        `strAlternateCodingSystemVersionID` - Specifies the version ID for the coding system .
        `strOriginalText` - Specifies the original text that was available to an automated process or a human before a specific code was assigned.
        `strSecondAlternateIdentifier` - Specifies a sequence of characters that uniquely identifies the second alternate code
        `strSecondAlternateText` - Specifies a the textual information of the second alternate code
        `strNameOfSecondAltenateCodingSystem` - Specifies the second coding scheme being used in the identifier component.
        `strSecondAlternateCodingSystemVersionID` - Specifies version ID of Second alternative coding system.
        `strCodingSystemOID` - contains the ISO Object identifier for the coding system.
        `strValueSetOID` - contains the value set from which CNE-1 is obtained
        `strValueSetVersionID` - contains the version of the value set identified by CNE-15.
        `strAlternateCodingSystemOID` - contains the ISO Object identifier for the alternate coding system
        `strAlternateValueSetOID` - contains the value set from which CNE-4 is obtained
        `strAlternateValueSetVersionID` - contains the version of the value set identified by CNE-18.
        `strSecondAlternateCodingSystemOID` - contains the value set from which CNE-12 is obtained
        `strSecondAlternateValueSetOID` - contains the value set from which CNE-10 is obtained
        `strSecondAlternateValueSetVersionID` - contains the version of the value set identified by CNE-21.

    - #### setBPBloodGroup

          public void setBPBloodGroup(CNE objbPBloodGroup)

      Set the BP Blood Group. This field specify the ABO/Rh blood group of the blood component.
      Parameters:
        `objbPBloodGroup` - Object of BP Blood Group.

    - #### setBPDateTimeofStatus

          public void setBPDateTimeofStatus(java.lang.String strTime)

      Set the BP Date Time of Status. This field specify the date and time that the status of the blood component is change.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setBPDateTimeofStatus

          public void setBPDateTimeofStatus(DTM objbPDateTimeofStatus)

      Set the BP Date Time of Status. This field specify the date and time that the status of the blood component is change.
      Parameters:
        `objbPDateTimeofStatus` - Object of BP Date Time of Status.

    - #### setBPDispensedtoReceiver

          public void setBPDispensedtoReceiver(java.lang.String strIDNumber,
                                      FN objFamilyName,
                                      java.lang.String strGivenName,
                                      java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                      java.lang.String strSuffix,
                                      java.lang.String strPrefix,
                                      CWE objSourceTable,
                                      HD objAssigningAuthority,
                                      java.lang.String strNameTypeCode,
                                      java.lang.String strIdentifierCheckDigit,
                                      java.lang.String strCheckDigitScheme,
                                      java.lang.String strIdentifierTypeCode,
                                      HD objAssigningFacility,
                                      java.lang.String strNameRepresentationCode,
                                      CWE objNameContext,
                                      java.lang.String strNameAssemblyOrder,
                                      java.lang.String strEffectiveDate,
                                      java.lang.String strExpirationDate,
                                      java.lang.String strProfessionalSuffix,
                                      CWE objAssigningJurisdiction,
                                      CWE objAssigningAgencyOrDepratment,
                                      java.lang.String strSecurityCheck,
                                      java.lang.String strSecurityCheckScheme)

      Set the BP Dispensed to Receiver.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `strSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### setBPDispensedtoReceiver

          public void setBPDispensedtoReceiver(XCN objbPDispensedtoReceiver)

      Set the BP Dispensed to Receiver.
      Parameters:
        `objbPDispensedtoReceiver` - Object of BP Dispensed to Receiver.

    - #### setBPDispenseStatus

          public void setBPDispenseStatus(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the BP Dispense Status. This field specify the current status of the specified blood product as indicated by the filler or placer.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setBPDispenseStatus

          public void setBPDispenseStatus(CWE objbPDispenseStatus)

      Set the BP Dispense Status. This field specify the current status of the specified blood product as indicated by the filler or placer.
      Parameters:
        `objbPDispenseStatus` - Object of BP Dispense Status.

    - #### setBPDispensingIndividual

          public void setBPDispensingIndividual(java.lang.String strIDNumber,
                                       FN objFamilyName,
                                       java.lang.String strGivenName,
                                       java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                       java.lang.String strSuffix,
                                       java.lang.String strPrefix,
                                       CWE objSourceTable,
                                       HD objAssigningAuthority,
                                       java.lang.String strNameTypeCode,
                                       java.lang.String strIdentifierCheckDigit,
                                       java.lang.String strCheckDigitScheme,
                                       java.lang.String strIdentifierTypeCode,
                                       HD objAssigningFacility,
                                       java.lang.String strNameRepresentationCode,
                                       CWE objNameContext,
                                       java.lang.String strNameAssemblyOrder,
                                       java.lang.String strEffectiveDate,
                                       java.lang.String strExpirationDate,
                                       java.lang.String strProfessionalSuffix,
                                       CWE objAssigningJurisdiction,
                                       CWE objAssigningAgencyOrDepratment,
                                       java.lang.String strSecurityCheck,
                                       java.lang.String strSecurityCheckScheme)

      Set the BP Dispensing Individual. This field specify the identify the individual who is dispensing the blood component or commercial product.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `strSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 0448 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### setBPDispensingIndividual

          public void setBPDispensingIndividual(XCN objbPDispensingIndividual)

      Set the BP Dispensing Individual. This field specify the identify the individual who is dispensing the blood component or commercial product.
      Parameters:
        `objbPDispensingIndividual` - Object of BP Dispensing Individual.

    - #### setBPExpirationDateTime

          public void setBPExpirationDateTime(java.lang.String strTime)

      Set the BP Expiration Date Time. This field specify the date and time that the blood product expires.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setBPExpirationDateTime

          public void setBPExpirationDateTime(DTM objbPExpirationDateTime)

      Set the BP Expiration Date Time. This field specify the date and time that the blood product expires.
      Parameters:
        `objbPExpirationDateTime` - Object of BP Expiration Date Time.

    - #### setBPQuantity

          public void setBPQuantity(java.lang.String strBPquantity)

      Set the BP Quantity. This field specify the number of blood components or commercial products to which this message refers.
      Parameters:
        `strBPquantity` - This field contains the String Value of BP Quantity

    - #### setBPQuantity

          public void setBPQuantity(NM objbPQuantity)

      Set the BP Quantity. This field specify the number of blood components or commercial products to which this message refers.
      Parameters:
        `objbPQuantity` - Object of BP Quantity.

    - #### setBPStatus

          public void setBPStatus(java.lang.String strBPstatus)

      Set the BP Status.
      Parameters:
        `strBPstatus` - String which to set as BP Status

    - #### setBPStatus

          public void setBPStatus(ID objbPStatus)

      Set the BP Status.
      Parameters:
        `objbPStatus` - object of BP Status.

    - #### setBPUniqueID

          public void setBPUniqueID(java.lang.String strEntityIdentifier,
                           java.lang.String strNamespaceId,
                           java.lang.String strUniversalId,
                           java.lang.String strUniversalIdType)

      Set the BP Unique ID. This field specify the unique system-generated number assigned to the blood product to which the message is referring.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setBPUniqueID

          public void setBPUniqueID(EI objbPUniqueID)

      Set the BP Unique ID. This field specify the unique system-generated number assigned to the blood product to which the message is referring.
      Parameters:
        `objbPUniqueID` - Object of BP Unique ID.

    - #### setBPUnits

          public void setBPUnits(java.lang.String strIdentifier,
                        java.lang.String strText,
                        java.lang.String strNameOfCodingSystem,
                        java.lang.String strAlternateIdentifier,
                        java.lang.String strAlternateText,
                        java.lang.String strNameOfAlternateCodingSystem,
                        java.lang.String strCodingSystemVersionID,
                        java.lang.String strAlternateCodingSystemVersionId,
                        java.lang.String strOriginalText,
                        java.lang.String strSecondAlternateIdentifier,
                        java.lang.String strSecondAlternateText,
                        java.lang.String strNameofSecondAlternateCodingSystem,
                        java.lang.String strSecondAlternateCodingSystemVersionID,
                        java.lang.String strCodingSystemOID,
                        java.lang.String strValueSetOID,
                        java.lang.String strValueSetVersionID,
                        java.lang.String strAlternateCodingSystemOID,
                        java.lang.String strAlternateValueSetOID,
                        java.lang.String strAlternateValueSetVersionID,
                        java.lang.String strSecondAlternateCodingSystemOID,
                        java.lang.String strSecondAlternateValueSetOID,
                        java.lang.String strSecondAlternateValueSetVersionID)

      Set the BP Units. This field specify the units of measure for the blood product amount.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setBPUnits

          public void setBPUnits(CWE objbPUnits)

      Set the BP Units. This field specify the units of measure for the blood product amount.
      Parameters:
        `objbPUnits` - Object of BP Units.

    - #### setCPCommercialProduct

          public void setCPCommercialProduct(java.lang.String strIdentifier,
                                    java.lang.String strText,
                                    java.lang.String strNameOfCodingSystem,
                                    java.lang.String strAlternateIdentifier,
                                    java.lang.String strAlternateText,
                                    java.lang.String strNameOfAlternateCodingSystem,
                                    java.lang.String strCodingSystemVersionID,
                                    java.lang.String strAlternateCodingSystemVersionId,
                                    java.lang.String strOriginalText,
                                    java.lang.String strSecondAlternateIdentifier,
                                    java.lang.String strSecondAlternateText,
                                    java.lang.String strNameofSecondAlternateCodingSystem,
                                    java.lang.String strSecondAlternateCodingSystemVersionID,
                                    java.lang.String strCodingSystemOID,
                                    java.lang.String strValueSetOID,
                                    java.lang.String strValueSetVersionID,
                                    java.lang.String strAlternateCodingSystemOID,
                                    java.lang.String strAlternateValueSetOID,
                                    java.lang.String strAlternateValueSetVersionID,
                                    java.lang.String strSecondAlternateCodingSystemOID,
                                    java.lang.String strSecondAlternateValueSetOID,
                                    java.lang.String strSecondAlternateValueSetVersionID)

      Set the CP Commercial Product. This field specify the code and/or text to identify a commercial product.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setCPCommercialProduct

          public void setCPCommercialProduct(CWE objcPCommercialProduct)

      Set the CP Commercial Product. This field specify the code and/or text to identify a commercial product.
      Parameters:
        `objcPCommercialProduct` - object of CP Commercial Product.

    - #### setCPLotNumber

          public void setCPLotNumber(java.lang.String strEntityIdentifier,
                            java.lang.String strNamespaceId,
                            java.lang.String strUniversalId,
                            java.lang.String strUniversalIdType)

      Set the CP Lot Number. This field specify the lot number for blood derivatives or commercially supplied items used as accessories to transfusion.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setCPLotNumber

          public void setCPLotNumber(EI objcPLotNumber)

      Set the CP Lot Number. This field specify the lot number for blood derivatives or commercially supplied items used as accessories to transfusion.
      Parameters:
        `objcPLotNumber` - object of CP Lot Number.

    - #### setCPManufacturer

          public void setCPManufacturer(java.lang.String strOrganizationName,
                               CWE objOrganizationNameTypeCode,
                               HD objAssigningAuthority,
                               java.lang.String strIdentifierTypeCode,
                               HD objAssigningFacility,
                               java.lang.String strNameRepresentationCode,
                               java.lang.String strOrganizationIdentifier)

      Set the CP Manufacturer. This field specify the manufacturer of the commercial product.
      Parameters:
        `strOrganizationName` - Specifies name of the specified organization.
        `strOrganizationNameTypeCode` - Specifies a code that represents the type of name i.e., legal name, display name. Suggested Values A,L,D,SL.[Refer to table No.0204]
        `objAssigningAuthority` - Specifies The assigning authority is a unique identifier of the system (or organization or agency or department) that creates the data.
        `strIdentifierTypeCode` - Specifies a code corresponding to the type of identifier.
        `objAssigningFacility` - Specifies The place or location identifier where the identifier was first assigned to the person.
        `strNameRepresentationCode` - Specifies representations of the same name/address Suggested values are I,A,P [Refer table 0465]
        `strOrganizationIdentifier` - This component contains the sequence of characters (the code) that uniquely identifies the item being referenced by XON.1 Organization Name. This component replaces XON.3 ID Number as of v 2.5.

    - #### setCPManufacturer

          public void setCPManufacturer(XON objcPManufacturer)

      Set the CP Manufacturer. This field specify the manufacturer of the commercial product.
      Parameters:
        `objcPManufacturer` - Object of CP Manufacturer.

    - #### setSetID_BPX

          public void setSetID_BPX(java.lang.String strSetID_BPX)

      Set the Set ID BPX. This field specify the sequence number for the BPX segment under the related BPO segment.
      Parameters:
        `strSetID_BPX` - This field contains the String Value of Set ID - BPX

    - #### setSetID_BPX

          public void setSetID_BPX(SI objsetID_BPX)

      Set the Set ID BPX. This field specify the sequence number for the BPX segment under the related BPO segment.
      Parameters:
        `objsetID_BPX` - Object of Set ID BPX.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Thrown when Segment Validation Fails.